/*
Copyright 2005  Vitaliy Shevchuk (shevit@users.sourceforge.net)

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.

*/

package org.ajaxanywhere;

import javax.servlet.jsp.tagext.BodyTagSupport;
import javax.servlet.jsp.JspException;
import javax.servlet.http.HttpServletRequest;
import java.io.IOException;

/**
 * @deprecated
 * @jsp.tag name = "watchJSFState"
 * display-name = "watchJSFState"
 * description = "@deprecated "
 */
public class WatchJSFStateTag extends BodyTagSupport {

    private String firstDelimiter;
    private String lastDelimiter;


    public String getFirstDelimiter() {
        return firstDelimiter;
    }

    /**
     * @jsp.attribute required="true"
     * rtexprvalue="true"
     * type="java.lang.String"
     * description="if JSF implementation saves its state on the client, this attribute indicates the beginning of state saving block"
     */
    public void setFirstDelimiter(String firstDelimiter) {
        this.firstDelimiter = firstDelimiter;
    }

    public String getLastDelimiter() {
        return lastDelimiter;
    }

    /**
     * @jsp.attribute required="true"
     * rtexprvalue="true"
     * type="java.lang.String"
     * description="if JSF implementation saves its state on the client, this attribute indicates the end of state saving block"
     */
    public void setLastDelimiter(String lastDelimiter) {
        this.lastDelimiter = lastDelimiter;
    }


    public int doAfterBody() throws JspException {
        try {
            if (bodyContent != null) {
                String content = bodyContent.getString();
                int p1 = content.indexOf(firstDelimiter);
                if (p1 != -1) {
                    p1+=firstDelimiter.length();
                    int p2 = content.indexOf(lastDelimiter, p1);
                    if (p2!=-1){
                        String stateContent = content.substring(p1, p2);
                        bodyContent.clearBody();
                        bodyContent.getEnclosingWriter().print(content.substring(0,p1));
                        bodyContent.getEnclosingWriter().print(AAUtils.getZoneStartDelimiter(AAConstants.JSF_STATE_KEY ));
                        bodyContent.getEnclosingWriter().print(stateContent);
                        bodyContent.getEnclosingWriter().print(AAUtils.getZoneEndDelimiter(AAConstants.JSF_STATE_KEY));
                        bodyContent.getEnclosingWriter().print(content.substring(p2));

                        if (AAUtils.isAjaxRequest(pageContext.getRequest())){
                            AAUtils.addZonesToRefresh((HttpServletRequest) pageContext.getRequest(),AAConstants.JSF_STATE_KEY);
                        }
                    }
                }
            }

            return super.doAfterBody();
        } catch (IOException e) {
            throw new JspException(e);
        }
    }
}
