package org.ajaxanywhere.jsf;

import javax.faces.webapp.UIComponentBodyTag;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.tagext.BodyContent;
import javax.servlet.jsp.tagext.BodyTag;
import javax.servlet.jsp.tagext.Tag;

/**
 * @jsp.tag name = "zoneJSF"
 * display-name = "zoneJSF"
 * description = ""
 */
public class ZoneJSFTag implements Tag, BodyTag {
    public String id;

    private static final String COMPONENT_TYPE = "org.ajaxanywhere.ZoneUIComponent";
    private UIComponentBodyTag uiComponentBodyTag;

    public ZoneJSFTag() {
        uiComponentBodyTag = new UIComponentBodyTag() {
            public String getComponentType() {
                return COMPONENT_TYPE;
            }

            public String getRendererType() {
                return null;
            }
        };
    }

    public void release() {
        id = null;
        uiComponentBodyTag.release();
    }

    public String getId() {
        return id;
    }

    public void setPageContext(PageContext pageContext) {
        id = null;
        uiComponentBodyTag.setPageContext(pageContext);
    }

    public Tag getParent() {
        return uiComponentBodyTag.getParent();
    }

    public void setParent(Tag parent) {
        uiComponentBodyTag.setParent(parent);
    }

    public int doStartTag() throws JspException {
        return uiComponentBodyTag.doStartTag();
    }

    public int doEndTag() throws JspException {
        return uiComponentBodyTag.doEndTag();
    }


    public int doAfterBody() throws JspException {
        return uiComponentBodyTag.doAfterBody();
    }

    public void doInitBody() throws JspException {
        uiComponentBodyTag.doInitBody();
    }


    public void setBodyContent(BodyContent bodyContent) {
        uiComponentBodyTag.setBodyContent(bodyContent);
    }

    /**
     * @param id String
     * @jsp.attribute required="true"
     * rtexprvalue="true"
     * type="java.lang.String"
     * description="name description"
     */
    public void setId(String id) {
        this.id = id;
        uiComponentBodyTag.setId(id);
    }

}
